#[doc = "Register `CTL7` reader"]
pub struct R(crate::R<CTL7_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<CTL7_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<CTL7_SPEC>> for R {
    fn from(reader: crate::R<CTL7_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `CTL7` writer"]
pub struct W(crate::W<CTL7_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<CTL7_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<CTL7_SPEC>> for W {
    fn from(writer: crate::W<CTL7_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `CTL` reader - Control register"]
pub struct CTL_R(crate::FieldReader<u8, u8>);
impl CTL_R {
    pub(crate) fn new(bits: u8) -> Self {
        CTL_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for CTL_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `CTL` writer - Control register"]
pub struct CTL_W<'a> {
    w: &'a mut W,
}
impl<'a> CTL_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | (value as u8 & 0xff);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - Control register"]
    #[inline(always)]
    pub fn ctl(&self) -> CTL_R {
        CTL_R::new((self.bits & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bits 0:7 - Control register"]
    #[inline(always)]
    pub fn ctl(&mut self) -> CTL_W {
        CTL_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Control Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ctl7](index.html) module"]
pub struct CTL7_SPEC;
impl crate::RegisterSpec for CTL7_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [ctl7::R](R) reader structure"]
impl crate::Readable for CTL7_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [ctl7::W](W) writer structure"]
impl crate::Writable for CTL7_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets CTL7 to value 0"]
impl crate::Resettable for CTL7_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
